/*
 * struct OPENFILENAME {
 *  0: unsigned long  lStructSize;
 *  1: HWND           hwndOwner;
 *  2: HINSTANCE      hInstance;
 *  3: const char*    lpstrFilter;
 *  4: char*          lpstrCustomFilter;
 *  5: unsigned long  nMaxCustFilter;
 *  6: unsigned long  nFilterIndex;
 *  7: char*          lpstrFile;
 *  8: unsigned long  nMaxFile;
 *  9: char*          lpstrFileTitle;
 * 10: unsigned long  nMaxFileTitle;
 * 11: const char*    lpstrInitialDir;
 * 12: const char*    lpstrTitle;
 * 13: unsigned long  Flags;
 * 14: unsigned short nFileOffset;
 *     unsigned short nFileExtension;
 * 15: const char*    lpstrDefExt;
 * 16: unsigned long  lCustData;
 * 17: LPOFNHOOKPROC  lpfnHook;
 * 18: const char*    lpTemplateName;
 * }; (19*4byte)
 */
long OFN_SetFilterPattern(long* pattern, long size, str describes, str filter)
{
	if (describes == 0) {
		FillMemory(pattern+size, 2, 0);
		return size+2;
	}
	CopyMemory(pattern+size, describes, StrLen(describes));
	FillMemory(pattern+size+StrLen(describes), StrLen(filter)+2, 0);
	CopyMemory(pattern+size+StrLen(describes)+1, filter, StrLen(filter));
	return size+StrLen(describes)+1+StrLen(filter)+1;
}

long OFN_READONLY             = 0x00000001;
long OFN_OVERWRITEPROMPT      = 0x00000002;
long OFN_HIDEREADONLY         = 0x00000004;
long OFN_NOCHANGEDIR          = 0x00000008;
long OFN_SHOWHELP             = 0x00000010;
long OFN_ENABLEHOOK           = 0x00000020;
long OFN_ENABLETEMPLATE       = 0x00000040;
long OFN_ENABLETEMPLATEHANDLE = 0x00000080;
long OFN_NOVALIDATE           = 0x00000100;
long OFN_ALLOWMULTISELECT     = 0x00000200;
long OFN_EXTENSIONDIFFERENT   = 0x00000400;
long OFN_PATHMUSTEXIST        = 0x00000800;
long OFN_FILEMUSTEXIST        = 0x00001000;
long OFN_CREATEPROMPT         = 0x00002000;
long OFN_SHAREAWARE           = 0x00004000;
long OFN_NOREADONLYRETURN     = 0x00008000;
long OFN_NOTESTFILECREATE     = 0x00010000;
long OFN_NONETWORKBUTTON      = 0x00020000;
long OFN_NOLONGNAMES          = 0x00040000;     // force no long names for 4.x modules
long OFN_EXPLORER             = 0x00080000;     // new look commdlg
long OFN_NODEREFERENCELINKS   = 0x00100000;
long OFN_LONGNAMES            = 0x00200000;     // force long names for 3.x modules
long OFN_ENABLEINCLUDENOTIFY  = 0x00400000;     // send include message to callback
long OFN_ENABLESIZING         = 0x00800000;

// Return values for the registered message sent to the hook function
// when a sharing violation occurs.  OFN_SHAREFALLTHROUGH allows the
// filename to be accepted, OFN_SHARENOWARN rejects the name but puts
// up no warning (returned when the app has already put up a warning
// message), and OFN_SHAREWARN puts up the default warning message
// for sharing violations.
//
// Note:  Undefined return values map to OFN_SHAREWARN, but are
//        reserved for future use.

long OFN_SHAREFALLTHROUGH = 2;
long OFN_SHARENOWARN      = 1;
long OFN_SHAREWARN        = 0;

//  #define CDN_FIRST   (0U-601U)
//  #define CDN_LAST    (0U-699U)

//  // Notifications when Open or Save dialog status changes
//  #define CDN_INITDONE            (CDN_FIRST - 0x0000)
//  #define CDN_SELCHANGE           (CDN_FIRST - 0x0001)
//  #define CDN_FOLDERCHANGE        (CDN_FIRST - 0x0002)
//  #define CDN_SHAREVIOLATION      (CDN_FIRST - 0x0003)
//  #define CDN_HELP                (CDN_FIRST - 0x0004)
//  #define CDN_FILEOK              (CDN_FIRST - 0x0005)
//  #define CDN_TYPECHANGE          (CDN_FIRST - 0x0006)
//  #define CDN_INCLUDEITEM         (CDN_FIRST - 0x0007)

//  #define CDM_FIRST       (WM_USER + 100)
//  #define CDM_LAST        (WM_USER + 200)

//  #define CC_RGBINIT               0x00000001
//  #define CC_FULLOPEN              0x00000002
//  #define CC_PREVENTFULLOPEN       0x00000004
//  #define CC_SHOWHELP              0x00000008
//  #define CC_ENABLEHOOK            0x00000010
//  #define CC_ENABLETEMPLATE        0x00000020
//  #define CC_ENABLETEMPLATEHANDLE  0x00000040
//  #if(WINVER >= 0x0400)
//  #define CC_SOLIDCOLOR            0x00000080
//  #define CC_ANYCOLOR              0x00000100
//  #endif /* WINVER >= 0x0400 */


//  #define FR_DOWN                         0x00000001
//  #define FR_WHOLEWORD                    0x00000002
//  #define FR_MATCHCASE                    0x00000004
//  #define FR_FINDNEXT                     0x00000008
//  #define FR_REPLACE                      0x00000010
//  #define FR_REPLACEALL                   0x00000020
//  #define FR_DIALOGTERM                   0x00000040
//  #define FR_SHOWHELP                     0x00000080
//  #define FR_ENABLEHOOK                   0x00000100
//  #define FR_ENABLETEMPLATE               0x00000200
//  #define FR_NOUPDOWN                     0x00000400
//  #define FR_NOMATCHCASE                  0x00000800
//  #define FR_NOWHOLEWORD                  0x00001000
//  #define FR_ENABLETEMPLATEHANDLE         0x00002000
//  #define FR_HIDEUPDOWN                   0x00004000
//  #define FR_HIDEMATCHCASE                0x00008000
//  #define FR_HIDEWHOLEWORD                0x00010000

//  #define CF_SCREENFONTS             0x00000001
//  #define CF_PRINTERFONTS            0x00000002
//  #define CF_BOTH                    (CF_SCREENFONTS | CF_PRINTERFONTS)
//  #define CF_SHOWHELP                0x00000004L
//  #define CF_ENABLEHOOK              0x00000008L
//  #define CF_ENABLETEMPLATE          0x00000010L
//  #define CF_ENABLETEMPLATEHANDLE    0x00000020L
//  #define CF_INITTOLOGFONTSTRUCT     0x00000040L
//  #define CF_USESTYLE                0x00000080L
//  #define CF_EFFECTS                 0x00000100L
//  #define CF_APPLY                   0x00000200L
//  #define CF_ANSIONLY                0x00000400L
//  #if(WINVER >= 0x0400)
//  #define CF_SCRIPTSONLY             CF_ANSIONLY
//  #endif /* WINVER >= 0x0400 */
//  #define CF_NOVECTORFONTS           0x00000800L
//  #define CF_NOOEMFONTS              CF_NOVECTORFONTS
//  #define CF_NOSIMULATIONS           0x00001000L
//  #define CF_LIMITSIZE               0x00002000L
//  #define CF_FIXEDPITCHONLY          0x00004000L
//  #define CF_WYSIWYG                 0x00008000L // must also have CF_SCREENFONTS & CF_PRINTERFONTS
//  #define CF_FORCEFONTEXIST          0x00010000L
//  #define CF_SCALABLEONLY            0x00020000L
//  #define CF_TTONLY                  0x00040000L
//  #define CF_NOFACESEL               0x00080000L
//  #define CF_NOSTYLESEL              0x00100000L
//  #define CF_NOSIZESEL               0x00200000L
//  #if(WINVER >= 0x0400)
//  #define CF_SELECTSCRIPT            0x00400000L
//  #define CF_NOSCRIPTSEL             0x00800000L
//  #define CF_NOVERTFONTS             0x01000000L
//  #endif /* WINVER >= 0x0400 */

//  // these are extra nFontType bits that are added to what is returned to the
//  // EnumFonts callback routine

//  #define SIMULATED_FONTTYPE    0x8000
//  #define PRINTER_FONTTYPE      0x4000
//  #define SCREEN_FONTTYPE       0x2000
//  #define BOLD_FONTTYPE         0x0100
//  #define ITALIC_FONTTYPE       0x0200
//  #define REGULAR_FONTTYPE      0x0400

//  // EnumFonts callback routine only uses these bits, so we can use the rest

//  // #define RASTER_FONTTYPE     0x001
//  // #define DEVICE_FONTTYPE     0x002
//  // #define TRUETYPE_FONTTYPE   0x004

//  #ifdef WINNT
//  #define OPENTYPE_FONTTYPE     0x10000
//  #define TYPE1_FONTTYPE        0x20000
//  #define DSIG_FONTTYPE         0x40000
//  #endif

//  #define WM_CHOOSEFONT_GETLOGFONT      (WM_USER + 1)
//  #define WM_CHOOSEFONT_SETLOGFONT      (WM_USER + 101)
//  #define WM_CHOOSEFONT_SETFLAGS        (WM_USER + 102)

//  // strings used to obtain unique window message for communication
//  // between dialog and caller

//  #define LBSELCHSTRINGA  "commdlg_LBSelChangedNotify"
//  #define SHAREVISTRINGA  "commdlg_ShareViolation"
//  #define FILEOKSTRINGA   "commdlg_FileNameOK"
//  #define COLOROKSTRINGA  "commdlg_ColorOK"
//  #define SETRGBSTRINGA   "commdlg_SetRGBColor"
//  #define HELPMSGSTRINGA  "commdlg_help"
//  #define FINDMSGSTRINGA  "commdlg_FindReplace"

//  #define LBSELCHSTRINGW  L"commdlg_LBSelChangedNotify"
//  #define SHAREVISTRINGW  L"commdlg_ShareViolation"
//  #define FILEOKSTRINGW   L"commdlg_FileNameOK"
//  #define COLOROKSTRINGW  L"commdlg_ColorOK"
//  #define SETRGBSTRINGW   L"commdlg_SetRGBColor"
//  #define HELPMSGSTRINGW  L"commdlg_help"
//  #define FINDMSGSTRINGW  L"commdlg_FindReplace"

//  #ifdef UNICODE
//  #define LBSELCHSTRING  LBSELCHSTRINGW
//  #define SHAREVISTRING  SHAREVISTRINGW
//  #define FILEOKSTRING   FILEOKSTRINGW
//  #define COLOROKSTRING  COLOROKSTRINGW
//  #define SETRGBSTRING   SETRGBSTRINGW
//  #define HELPMSGSTRING  HELPMSGSTRINGW
//  #define FINDMSGSTRING  FINDMSGSTRINGW
//  #else
//  #define LBSELCHSTRING  LBSELCHSTRINGA
//  #define SHAREVISTRING  SHAREVISTRINGA
//  #define FILEOKSTRING   FILEOKSTRINGA
//  #define COLOROKSTRING  COLOROKSTRINGA
//  #define SETRGBSTRING   SETRGBSTRINGA
//  #define HELPMSGSTRING  HELPMSGSTRINGA
//  #define FINDMSGSTRING  FINDMSGSTRINGA
//  #endif

//  // HIWORD values for lParam of commdlg_LBSelChangeNotify message
//  #define CD_LBSELNOITEMS -1
//  #define CD_LBSELCHANGE   0
//  #define CD_LBSELSUB      1
//  #define CD_LBSELADD      2

//  #define PD_ALLPAGES                    0x00000000
//  #define PD_SELECTION                   0x00000001
//  #define PD_PAGENUMS                    0x00000002
//  #define PD_NOSELECTION                 0x00000004
//  #define PD_NOPAGENUMS                  0x00000008
//  #define PD_COLLATE                     0x00000010
//  #define PD_PRINTTOFILE                 0x00000020
//  #define PD_PRINTSETUP                  0x00000040
//  #define PD_NOWARNING                   0x00000080
//  #define PD_RETURNDC                    0x00000100
//  #define PD_RETURNIC                    0x00000200
//  #define PD_RETURNDEFAULT               0x00000400
//  #define PD_SHOWHELP                    0x00000800
//  #define PD_ENABLEPRINTHOOK             0x00001000
//  #define PD_ENABLESETUPHOOK             0x00002000
//  #define PD_ENABLEPRINTTEMPLATE         0x00004000
//  #define PD_ENABLESETUPTEMPLATE         0x00008000
//  #define PD_ENABLEPRINTTEMPLATEHANDLE   0x00010000
//  #define PD_ENABLESETUPTEMPLATEHANDLE   0x00020000
//  #define PD_USEDEVMODECOPIES            0x00040000
//  #define PD_USEDEVMODECOPIESANDCOLLATE  0x00040000
//  #define PD_DISABLEPRINTTOFILE          0x00080000
//  #define PD_HIDEPRINTTOFILE             0x00100000
//  #define PD_NONETWORKBUTTON             0x00200000

//  #define DN_DEFAULTPRN      0x0001


//  #if(WINVER >= 0x0400)
//  #define WM_PSD_PAGESETUPDLG     (WM_USER  )
//  #define WM_PSD_FULLPAGERECT     (WM_USER+1)
//  #define WM_PSD_MINMARGINRECT    (WM_USER+2)
//  #define WM_PSD_MARGINRECT       (WM_USER+3)
//  #define WM_PSD_GREEKTEXTRECT    (WM_USER+4)
//  #define WM_PSD_ENVSTAMPRECT     (WM_USER+5)
//  #define WM_PSD_YAFULLPAGERECT   (WM_USER+6)

//  #define PSD_DEFAULTMINMARGINS             0x00000000 // default (printer's)
//  #define PSD_INWININIINTLMEASURE           0x00000000 // 1st of 4 possible

//  #define PSD_MINMARGINS                    0x00000001 // use caller's
//  #define PSD_MARGINS                       0x00000002 // use caller's
//  #define PSD_INTHOUSANDTHSOFINCHES         0x00000004 // 2nd of 4 possible
//  #define PSD_INHUNDREDTHSOFMILLIMETERS     0x00000008 // 3rd of 4 possible
//  #define PSD_DISABLEMARGINS                0x00000010
//  #define PSD_DISABLEPRINTER                0x00000020
//  #define PSD_NOWARNING                     0x00000080 // must be same as PD_*
//  #define PSD_DISABLEORIENTATION            0x00000100
//  #define PSD_RETURNDEFAULT                 0x00000400 // must be same as PD_*
//  #define PSD_DISABLEPAPER                  0x00000200
//  #define PSD_SHOWHELP                      0x00000800 // must be same as PD_*
//  #define PSD_ENABLEPAGESETUPHOOK           0x00002000 // must be same as PD_*
//  #define PSD_ENABLEPAGESETUPTEMPLATE       0x00008000 // must be same as PD_*
//  #define PSD_ENABLEPAGESETUPTEMPLATEHANDLE 0x00020000 // must be same as PD_*
//  #define PSD_ENABLEPAGEPAINTHOOK           0x00040000
//  #define PSD_DISABLEPAGEPAINTING           0x00080000
//  #define PSD_NONETWORKBUTTON               0x00200000 // must be same as PD_*
//  #endif /* WINVER >= 0x0400 */

// Local Variables:
// mode: C++
// End:
