#include <windows.h>
#include <stdio.h>
#include "bass.h"
#define EXPORT extern "C" __declspec(dllexport)

EXPORT long bass_init (long *p) {
	int device;
	DWORD freq,flags;
	
	device = (int)p[0];
	freq   = (DWORD)p[1];
	flags  = (DWORD)p[2];	
	
	if (BASS_Init(device,freq,flags,0))
		return 0;
	else
		return 1;
}
EXPORT long bass_start (long *) {
	if(BASS_Start())
		return 1;
	else
		return 0;
}
EXPORT long bass_stop (long *) {
	if(BASS_Stop())
		return 1;
	else
		return 0;
}
EXPORT long bass_pause (long *) {
	if(BASS_Pause())
		return 1;
	else
		return 0;
}
EXPORT long bass_free (long *) {
	BASS_Free();
	return 0;
}
EXPORT long bass_streamcreate (long *p) {
	HSTREAM bgm;
	char  *fn;
	DWORD opt;
	
	fn   = (char*)(p[0]);
	opt  = (DWORD)p[1];
	bgm = BASS_StreamCreateFile(FALSE,(void*)fn,0,0,opt);
	return (long)bgm;
}
EXPORT long bass_streamplay (long *p) {
	if(BASS_StreamPlay((HSTREAM)p[0],FALSE,(DWORD)p[1]))
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_streamfree (long *p) {
	BASS_StreamFree((HSTREAM)p[0]);
	return 0;
}
EXPORT long bass_musicload (long *p) {
	HMUSIC mod;
	char  *fn;
	DWORD opt;
	
	fn   = (char*)(p[0]);
	opt  = (DWORD)p[1];
	mod = BASS_MusicLoad(FALSE,(void*)fn,0,0,opt);
	return (long)mod;
}
EXPORT long bass_musicplay (long *p) {
	if(BASS_MusicPlay((HMUSIC)p[0]))
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_musicsetamplify (long *p) {
	if ( BASS_MusicSetAmplify((HMUSIC)p[0],(DWORD)p[1]) )
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_musicsetpansep (long *p) {
	if ( BASS_MusicSetPanSep((HMUSIC)p[0],(DWORD)p[1]) )
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_musicfree (long *p) {
	BASS_MusicFree((HMUSIC)p[0]);
	return 0;
}
EXPORT long bass_sampleload (long *p) {
	HSAMPLE wav;
	char  *fn;
	DWORD max,opt;
	
	fn   = (char*)(p[0]);
	max  = (DWORD)p[1];
	if (max<1) max=1; else if (max>65535) max=65535;
	opt  = (DWORD)p[2];
	wav = BASS_SampleLoad(FALSE,(void*)fn,0,0,max,opt);
	return (long)wav;
}
EXPORT long bass_sampleplay (long *p) {
	return (long)BASS_SamplePlay((HSAMPLE)p[0]);
}
EXPORT long bass_samplefree (long *p) {
	BASS_SampleFree((HSAMPLE)p[0]);
	return 0;
}
EXPORT long bass_getversion (long *) {
	return (long)BASS_GetVersion();
}
EXPORT long bass_getcpu (long *) {
	return (long)BASS_GetVolume();
}
EXPORT long bass_getvolume (long *) {
	return (long)BASS_GetCPU();
}
EXPORT long bass_getmusicvolume (long *) {
	DWORD vol;
	BASS_GetGlobalVolumes(&vol,NULL,NULL);
	return (long)vol;
}
EXPORT long bass_getsamplevolume (long *) {
	DWORD vol;
	BASS_GetGlobalVolumes(NULL,&vol,NULL);
	return (long)vol;
}
EXPORT long bass_getstreamvolume (long *) {
	DWORD vol;
	BASS_GetGlobalVolumes(NULL,NULL,&vol);
	return (long)vol;
}
EXPORT long bass_setvolume (long *p) {
	if(BASS_SetVolume((DWORD)p[0]))
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_setmusicvolume (long *p) {
	BASS_SetGlobalVolumes(p[0],-1,-1);
	return 0;
}
EXPORT long bass_setsamplevolume (long *p) {
	BASS_SetGlobalVolumes(-1,p[0],-1);
	return 0;
}
EXPORT long bass_setstreamvolume (long *p) {
	BASS_SetGlobalVolumes(-1,-1,p[0]);
	return 0;
}
EXPORT long bass_errorgetcode (long *) {
	return (long)BASS_ErrorGetCode();
}

EXPORT long bass_channelslidevolume (long *p) {
	if( BASS_ChannelSlideAttributes((DWORD)p[0],-1,(int)p[1],-101,(DWORD)p[2]) )
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_channelissliding (long *p) {
	if( BASS_ChannelIsSliding((DWORD)p[0])&BASS_SLIDE_VOL )
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_channelisactive (long *p) {
	return (long)BASS_ChannelIsActive((DWORD)p[0]);
}

EXPORT long bass_channelstop (long *p) {
	return (long)BASS_ChannelStop((DWORD)p[0]);
}

EXPORT long bass_channelpause (long *p) {
	return (long)BASS_ChannelPause((DWORD)p[0]);
}

EXPORT long bass_channelresume (long *p) {
	return (long)BASS_ChannelResume((DWORD)p[0]);
}

struct SDllTable {
	LPSTR	lpFuncName;
	LONG	(*lpFunc)(LONG*);
};
extern "C" __declspec( dllexport ) SDllTable* InquireFunction(void){
	static SDllTable S[] = {
		//	ɁADLLŎgĂ֐񋓂
		"bass_init",bass_init,
		"bass_start",bass_start,
		"bass_stop",bass_stop,
		"bass_pause",bass_pause,
		"bass_free",bass_free,
		"bass_streamcreate",bass_streamcreate,
		"bass_streamplay",bass_streamplay,
		"bass_streamfree",bass_streamfree,
		"bass_musicload",bass_musicload,
		"bass_musicplay",bass_musicplay,
		"bass_musicsetamplify",bass_musicsetamplify,
		"bass_musicsetpansep",bass_musicsetpansep,
		"bass_musicfree",bass_musicfree,
		"bass_sampleload",bass_sampleload,
		"bass_sampleplay",bass_sampleplay,
		"bass_samplefree",bass_samplefree,
		"bass_getversion",bass_getversion,
		"bass_getcpu",bass_getcpu,
		"bass_getvolume",bass_getvolume,
		"bass_getmusicvolume",bass_getmusicvolume,
		"bass_getsamplevolume",bass_getsamplevolume,
		"bass_getstreamvolume",bass_getstreamvolume,
		"bass_setvolume",bass_setvolume,
		"bass_setmusicvolume",bass_setmusicvolume,
		"bass_setsamplevolume",bass_setsamplevolume,
		"bass_setstreamvolume",bass_setstreamvolume,
		"bass_errorgetcode",bass_errorgetcode,
		"bass_channelslidevolume",bass_channelslidevolume,
		"bass_channelissliding",bass_channelissliding,
		"bass_channelisactive",bass_channelisactive,
		"bass_channelstop",bass_channelstop,
		"bass_channelpause",bass_channelpause,
		"bass_channelresume",bass_channelresume,
		NULL,NULL	// ŌNULL,NULL
	};
	return &S[0];
}

int WINAPI DllMain(HINSTANCE, DWORD, PVOID)
{ return TRUE; }
