#include <windows.h>
#include <stdio.h>
#include "bass.h"
#define EXPORT extern "C" __declspec(dllexport)

/* Config */
EXPORT long bass_GetSampleVolume (long *) {
	return BASS_GetConfig(BASS_CONFIG_GVOL_SAMPLE);
}
EXPORT long bass_GetStreamVolume (long *) {
	return BASS_GetConfig(BASS_CONFIG_GVOL_STREAM);
}
EXPORT long bass_GetMusicVolume (long *) {
	return BASS_GetConfig(BASS_CONFIG_GVOL_MUSIC);
}
EXPORT long bass_SetSampleVolume (long *p) {
	return BASS_SetConfig(BASS_CONFIG_GVOL_SAMPLE ,(DWORD)p[0]);
}
EXPORT long bass_SetStreamVolume (long *p) {
	return BASS_SetConfig(BASS_CONFIG_GVOL_STREAM ,(DWORD)p[0]);
}
EXPORT long bass_SetMusicVolume (long *p) {
	return BASS_SetConfig(BASS_CONFIG_GVOL_MUSIC ,(DWORD)p[0]);
}

/* Initialization, info, etc... */
EXPORT long bass_Init (long *p) {
	int device;
	DWORD freq,flags;
	
	device = (int)p[0];
	freq   = (DWORD)p[1];
	flags  = (DWORD)p[2];	
	
	return BASS_Init(device, freq, flags, 0, NULL) ? 0 : 1;
}
EXPORT long bass_Start (long *) {
	return BASS_Start();
}
EXPORT long bass_Stop (long *) {
	return BASS_Stop();
}
EXPORT long bass_Pause (long *) {
	return BASS_Pause();
}
EXPORT long bass_Free (long *) {
	return BASS_Free();
}
EXPORT long bass_GetCPU (long *) {
	return (long)BASS_GetCPU();
}
EXPORT long bass_GetVersion (long *) {
	return (long)BASS_GetVersion();
}
EXPORT long bass_GetVolume (long *) {
	return (long)BASS_GetCPU();
}
EXPORT long bass_SetVolume (long *p) {
	return BASS_SetVolume((DWORD)p[0]);
}

EXPORT long bass_ErrorGetCode (long *) {
	return (long)BASS_ErrorGetCode();
}

/* Samples */
EXPORT long bass_SampleLoad (long *p) {
	HSAMPLE wav;
	char  *fn;
	DWORD max, flags;
	
	fn   = (char*)(p[0]);
	max  = (DWORD)p[1];
	if (max<1) max=1; else if (max>65535) max=65535;
	flags  = (DWORD)p[2];
	return (long)BASS_SampleLoad(FALSE, (void*)fn, 0, 0, max, flags);
}

EXPORT long bass_SamplePlay (long *p) {
	HCHANNEL ch = BASS_SampleGetChannel((HSAMPLE)p[0], FALSE);
	return (long)BASS_ChannelPlay(ch, FALSE);
}

EXPORT long bass_SampleStop (long *p) {
	return BASS_SampleStop((HSAMPLE)p[0]);
}
EXPORT long bass_SampleFree (long *p) {
	return BASS_SampleFree((HSAMPLE)p[0]);
}

/* Streams */
EXPORT long bass_StreamCreate (long *p) {
	HSTREAM bgm;
	char  *fn;
	DWORD flags;
	
	fn    = (char*)(p[0]);
	flags = (DWORD)p[1];
	bgm = BASS_StreamCreateFile(FALSE, (void*)fn, 0, 0, flags);
	return (long)bgm;
}
/*
EXPORT long bass_streamplay (long *p) {
	if(BASS_StreamPlay((HSTREAM)p[0],FALSE,(DWORD)p[1]))
		return TRUE;
	else
		return FALSE;
}
*/
EXPORT long bass_StreamFree (long *p) {
	return BASS_StreamFree((HSTREAM)p[0]);
}

/* MOD/MO3 music */
EXPORT long bass_MusicLoad (long *p) {
	HMUSIC mod;
	char  *fn;
	DWORD flags;
	
	fn     = (char*)(p[0]);
	flags  = (DWORD)p[1];
	mod = BASS_MusicLoad(FALSE, (void*)fn, 0, 0, flags, 0);
	return (long)mod;
}
/*
EXPORT long bass_musicplay (long *p) {
	if(BASS_MusicPlay((HMUSIC)p[0]))
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_musicsetamplify (long *p) {
	if ( BASS_MusicSetAmplify((HMUSIC)p[0],(DWORD)p[1]) )
		return TRUE;
	else
		return FALSE;
}
EXPORT long bass_musicsetpansep (long *p) {
	if ( BASS_MusicSetPanSep((HMUSIC)p[0],(DWORD)p[1]) )
		return TRUE;
	else
		return FALSE;
}
*/
EXPORT long bass_MusicFree (long *p) {
	return BASS_MusicFree((HMUSIC)p[0]);
}

/* Channels */
EXPORT long bass_ChannelPlay (long *p) {
	return (long)BASS_ChannelPlay((DWORD)p[0], (p[1]>0) ? 1 :0);
}
EXPORT long bass_ChannelIsActive (long *p) {
	return (long)BASS_ChannelIsActive((DWORD)p[0]);
}
EXPORT long bass_ChannelPause (long *p) {
	return (long)BASS_ChannelPause((DWORD)p[0]);
}
EXPORT long bass_ChannelStop (long *p) {
	return (long)BASS_ChannelStop((DWORD)p[0]);
}
EXPORT long bass_ChannelGetPosition (long *p) {
	return (long)BASS_ChannelGetPosition((DWORD)p[0]);
}
EXPORT long bass_ChannelSetPosition (long *p) {
	return (long)BASS_ChannelSetPosition((DWORD)p[0], (QWORD)p[1]);
}
EXPORT long bass_ChannelGetVolume (long *p) {
	DWORD volume;
	if (BASS_ChannelGetAttributes((DWORD)p[0], NULL, &volume, NULL))
		return volume;
	else
		return -1;
}
EXPORT long bass_ChannelGetPan (long *p) {
	int pan;
	if (BASS_ChannelGetAttributes((DWORD)p[0], NULL, NULL, &pan))
		return pan;
	else
		return -1;
}
EXPORT long bass_ChannelSetVolume (long *p) {
	return BASS_ChannelSetAttributes((DWORD)p[0], -1, (int)p[1], -101);
}
EXPORT long bass_ChannelSetPan (long *p) {
	return BASS_ChannelSetAttributes((DWORD)p[0], -1, -1, (int)p[1]);
}

EXPORT long bass_ChannelSlideVolume (long *p) {
	return BASS_ChannelSlideAttributes((DWORD)p[0], -1, (int)p[1], -101, (DWORD)p[2]);
}
EXPORT long bass_ChannelIsSliding (long *p) {
	return (BASS_ChannelIsSliding((DWORD)p[0]) & BASS_SLIDE_VOL);
}

struct SDllTable {
	LPSTR	lpFuncName;
	LONG	(*lpFunc)(LONG*);
};
extern "C" __declspec( dllexport ) SDllTable* InquireFunction(void){
	static SDllTable S[] = {
		//	ɁADLLŎgĂ֐񋓂
		"bass_GetSampleVolume", bass_GetSampleVolume,
		"bass_GetStreamVolume", bass_GetStreamVolume,
		"bass_GetMusicVolume", bass_GetMusicVolume,
		"bass_SetSampleVolume", bass_SetSampleVolume,
		"bass_SetStreamVolume", bass_SetStreamVolume,
		"bass_SetMusicVolume", bass_SetMusicVolume,
		"bass_Init", bass_Init,
		"bass_Start", bass_Start,
		"bass_Stop", bass_Stop,
		"bass_Pause", bass_Pause,
		"bass_Free", bass_Free,
		"bass_GetCPU", bass_GetCPU,
		"bass_GetVersion", bass_GetVersion,
		"bass_GetVolume", bass_GetVolume,
		"bass_SetVolume", bass_SetVolume,
		"bass_ErrorGetCode", bass_ErrorGetCode,
		"bass_SampleLoad", bass_SampleLoad,
		"bass_SamplePlay", bass_SamplePlay,
		"bass_SampleStop", bass_SampleStop,
		"bass_SampleFree", bass_SampleFree,
		"bass_StreamCreate", bass_StreamCreate,
		"bass_StreamFree", bass_StreamFree,
		"bass_MusicLoad", bass_MusicLoad,
		"bass_MusicFree", bass_MusicFree,
		"bass_ChannelPlay", bass_ChannelPlay,
		"bass_ChannelIsActive", bass_ChannelIsActive,
		"bass_ChannelPause", bass_ChannelPause,
		"bass_ChannelStop", bass_ChannelStop,
		"bass_ChannelGetPosition", bass_ChannelGetPosition,
		"bass_ChannelSetPosition", bass_ChannelSetPosition,
		"bass_ChannelGetVolume", bass_ChannelGetVolume,
		"bass_ChannelGetPan", bass_ChannelGetPan,
		"bass_ChannelSetVolume", bass_ChannelSetVolume,
		"bass_ChannelSetPan", bass_ChannelSetPan,
		"bass_ChannelSlideVolume", bass_ChannelSlideVolume,
		"bass_ChannelIsSliding", bass_ChannelIsSliding,
		NULL,NULL	// ŌNULL,NULL
	};
	return &S[0];
}

int WINAPI DllMain(HINSTANCE, DWORD, PVOID)
{ return TRUE; }
