#ifndef FOESYSTEM_H_
#define FOESYSTEM_H_

#include "Foe.h"
#include "MyRunner.h"
#include "libBulletML/bulletmlparser.h"
#include "libBulletML/bulletmlparser-tinyxml.h"

class FoeSystem {
  private:
	//members
	Foe *foes;
	int max0, max;

	//methods
	int akiBullet(void);

  public:
	//methods
	FoeSystem(int max0) {
		this->max0 = max0;
		this->max  = max0;
		foes = new Foe[max0];
	}
	~FoeSystem() {
		delete []foes;
	}
	int init(int max) {
		if ((max<0)||(max>max0)) return -1;
		this->max = max;
		return max;
	}
	Foe* get(int no) {
		return &foes[no];
	}
/*
	void free() {
		delete []foes;
		foes = NULL;
	}
*/
	int simple(int no, double direction, double dx, double dy);
	int simple(double x, double y, double dx, double dy, long type);
	int simple2(double x, double y, double dir, double spd, long type);
	int action(int no, BulletMLState* state, double direction, double speed, double rank, double rot);
	int action(double x, double y, BulletMLParserTinyXML* parser, double rank, long type, double multi, double rot);
	void run(void);
};

#endif
