#include <math.h>
#include "MyRunner.h"
#include "Foe.h"
#include "FoeSystem.h"
//#include "ygs_bulletml.h"

extern double jx,jy;
extern int tick;
extern double rank;
extern FoeSystem* foesys;
//extern double rot;

MyRunner::MyRunner(int no, BulletMLParser* parser, double rank, double rot) : BulletMLRunner(parser) {
	this->no = no;
	this->rank = rank;
	this->rot = rot;
	//	x = x0; y = y0;
	dir=180; spd=0;
	accelx=0; accely=0;
}
MyRunner::MyRunner(int no, BulletMLState* state, double dir, double spd, double rank, double rot) : BulletMLRunner(state) {
	this->no = no;
//	x = x0; y = y0;
	this->dir = dir;
	this->spd = spd;
	this->rank = rank;
	this->rot = rot;
	accelx=0; accely=0;
}
double MyRunner::getBulletDirection() { return dir; }
double MyRunner::getAimDirection() {
	double r;
	double x = foesys->get(no)->x;
	double y = foesys->get(no)->y;

	int dx = (int)(x-jx);
	int dy = (int)(jy-y);
	if((dx==0)&&(dy==0)) {
		r = 180;
	} else {
		r = atan2((double)dx, (double)dy)/M_PI*180 + 180 - rot;
		if (rot < 0) r += 360;
	}
	return r;
}
double MyRunner::getBulletSpeed() {return this->spd;}
double MyRunner::getDefaultSpeed() {return 1;}
double MyRunner::getRank() {return this->rank;}

void MyRunner::createSimpleBullet(double direction, double speed) {
	foesys->simple(no, direction+rot, sin((direction+rot)/180*3.14)*speed, -cos((direction+rot)/180*3.14)*speed);
	/*
	Bullet* b = bullets.akiBullet();
	if(b != NULL) {
		b->init(bullet->x, bullet->y, sin(direction/180*3.14)*speed, -cos(direction/180*3.14)*speed);
//		printf("SimpleBullet(%f/%f) %d\n", direction, speed, n);
		tama++;
	}
	*/
}
void MyRunner::createBullet(BulletMLState* state, double direction, double speed) {
	int no2 = foesys->action(no, state, direction, speed, rank, rot);
	if(no2 < 0) delete state;
	/*
	Bullet* b = bullets.akiBullet();
	if(b != NULL) {
		b->init(bullet->x, bullet->y, new MyRunner(state,dir,spd) );
//		bullets[n].dx = sin(direction/180*3.14)*speed;
//		bullets[n].dy = -cos(direction/180*3.14)*speed;
//		printf("Bullet(%f/%f) %d\n", direction, speed, n);
	} else {
		delete state;
	}
	*/
}

int  MyRunner::getTurn() { return tick; }
void MyRunner::doVanish() {
//		printf("Vanished %d\n",no);
		foesys->get(no)->vanish2();
}

// ----- KvΎ֐Q̎n܂ -----
void MyRunner::doChangeDirection(double direction) { dir = direction; } 
void MyRunner::doChangeSpeed(double speed) { spd = speed; }
void MyRunner::doAccelX(double dx) { accelx = dx; }
void MyRunner::doAccelY(double dy) { accely = dy; }
double MyRunner::getBulletSpeedX() {return sin((dir+rot)/180*3.14)*spd  + accelx; }
double MyRunner::getBulletSpeedY() {return -cos((dir+rot)/180*3.14)*spd + accely; }
// ----- KvΎ֐Q̏I -----
