#ifndef MYRUNNER_H_
#define MYRUNNER_H_

#include "libBulletML/bulletmlparser.h"
#include "libBulletML/bulletmlparser-tinyxml.h"
#include "libBulletML/bulletmlrunner.h"
#include "rand.h"

class MyRunner : public BulletMLRunner {
 private:
	int no;
//	double x,y;
	double dir, spd;
	double accelx,accely;
	double rank;

 public:
	double rot;
	/* methods */
    MyRunner(int no, BulletMLParser* parser, double rank, double rot);
    MyRunner(int no, BulletMLState* state, double dir, double spd, double rank, double rot);
    ~MyRunner() {}
    double getBulletDirection();
    double getAimDirection();
    double getBulletSpeed();
    double getDefaultSpeed();
    double getRank();
    void createSimpleBullet(double direction, double speed);
    void createBullet(BulletMLState* state, double direction, double speed);
    int getTurn();
    void doVanish();
//	double getDX() {return sin(dir/180*3.14)*spd; }
//	double getDY() {return -cos(dir/180*3.14)*spd; }

// ----- KvΎ֐Q̎n܂ -----
  void doChangeDirection(double direction);
  void doChangeSpeed(double speed);
  void doAccelX(double dx);
  void doAccelY(double dy);
  double getBulletSpeedX();
  double getBulletSpeedY();
// ----- KvΎ֐Q̏I -----
  double getRand() { return (double)(nextRand() & 0xffff)/65536; }
};

#endif // ! MYRUNNER_H_
