// yaneFile.h
//
//	standard file stream wrapper
//		programmed by yaneurao '00/02/25
//		modified for yanePackDx '02/03/13

#ifndef __yaneFile_h__
#define __yaneFile_h__

class IFile {
public:
	virtual LRESULT		Open(const string& filename,const string& access)=0;
	virtual LRESULT		Write(const string&)=0;
	virtual LRESULT		Close()=0;
	virtual FILE*		GetFilePtr()const=0;
	virtual LRESULT		Read(const string& filename)=0;
	virtual string		GetName()const=0;
	virtual string		GetPureFileName()=0;
	virtual string		GetSuffix()=0;
	virtual LPVOID		GetMemory()const=0;
	virtual DWORD		GetSize()const=0;
	virtual LRESULT		ReadLine(LPSTR buf,DWORD dwSize=256)=0;
	virtual LRESULT		ReadLine2(LPSTR buf,DWORD dwSize=512)=0;
	virtual LRESULT		ReadLine(string&s)=0;
	virtual void		Reset()=0;
	virtual LRESULT		ReadData(BYTE*p,DWORD size)=0;
	virtual LRESULT		Write(const string& filename,LPVOID mem,DWORD size)=0;
	virtual LRESULT		WriteBack(const string& filename)=0;
	virtual LRESULT		Encode()=0;
	virtual LRESULT		Delete(const string& filename)=0;
	virtual LRESULT		CreateTemporary()=0;
	virtual LRESULT		Load(const string& filename,vector<BYTE>*vData)=0;
	virtual LRESULT		Save(const string& filename,vector<BYTE>*vData)=0;
	virtual LRESULT		Save(const string& filename,vector<string>*vData)=0;
	virtual ~IFile(){}
};

class CFile : public IFile {
/**
t@C̓o͗p̃NXłB

ǂݍ݂́AyanePack`(t@Cɂ鍇)AyanePackEx`
(LZSS@ɂ鈳k),yanePackDx`(TutH_kΉyanePackEx)
̃t@CΉĂ܂B

݂́AcOȂAyanePack/yanePackEx`̃t@Cɂ͏߂܂B

yanePack`^yanePackEx`^yanePackDx`̎dlɂĂ͌q܂B
yanePack`^yanePackEx`^yanePackDx̃t@C邽߂ɂ́AʓrA
yanePack^yanePackEx^yanePackDxpӂB


yanePack̎dl(yaneuraoGameSDK1.00ŃT|[gĂ`^݊̂ߓǂݍ߂܂)

@e

yanePacḱAt@Cɂ܂Ƃ߂邽߂̂̂łBik͂܂j

CFilëꊇǂݍ݌n̊֐Ȃ΁AyanePack`ł邱Ƃӎɓǂݏo\łB

 <yanepackp\̂ɂ>
// t@Cwb_[ "yanepack" 8oCg + i[t@CDWORDłāA
// ̌AȉCFileInfoi[t@CāAƂ̓f[^łB
struct CFileInfo {
char filename[32];
DWORD startpos; // seek pos(t@C擪̃ItZbg)
size_t filesize; @@// file sizeĩt@C̃TCYj
};

t@C̊gqdatɂĂB
--------------------------------------------------------------------------------yanePackd̎dl(yaneuraoGameSDK2ndŃT|[g`j
--------------------------------------------------------------------------------@e
yanePackEx́At@Cɂ܂Ƃ߁Ak邽߂̂̂łBkɂLZSS@p܂iCLZSSNX̂܂ܗp܂j
 <yanepackExp\̂ɂ>
// t@Cwb_[ "yanepkEx" 8oCg + i[t@CDWORDłāA
// ̌AȉCFileInfoi[t@CāAƂ̓f[^łB
struct CFileInfo {
char filename[32];
DWORD startpos; // seek pos(t@C擪̃ItZbg)
size_t filesize; @@// file sizeĩt@C̈kTCYj
size_t packsize;@ // packsizeĩt@C̓WJ̃TCY)
// 񈳏k̃t@ĆAfilesize==packsizeƂȂĂ܂
};
t@C̊gqdatɂĂB
--------------------------------------------------------------------------------yanePackc̎dl(yaneuraoGameSDK3rdŃT|[g`j
--------------------------------------------------------------------------------@e
yanePackDx́AyanePackEx̃tH_ΉłłB
 <yanepackDxp\̂ɂ>
// t@Cwb_[ "yanepkDx" 8oCg + i[t@CDWORDłāA
// ̌AȉCFileInfoi[t@CāAƂ̓f[^łB
struct CFileInfo {
char filename[256];
DWORD startpos; // seek pos(t@C擪̃ItZbg)
size_t filesize; @@// file sizeĩt@C̈kTCYj
size_t packsize;@ // packsizeĩt@C̓WJ̃TCY)
// 񈳏k̃t@ĆAfilesize==packsizeƂȂĂ܂
};
t@C̊gqdatɂĂB
t@ĆA
	"test\subfolder\sample.txt"
̂悤ɁAtH_tŊi[Ă邱Ƃ܂B
āA
	CFile::Read́A
		"test\subfolder\sample.txt"
	Ƃt@C΁A
		"test\subfolder.dat" ̂Ȃ"sample.txt"
	ꂪ
		"test.dat"̂Ȃ"subfolder\sample.txt"
	Ƃ悤ɁA[gfBNg܂őkyČĂ܂B

*/
public:
	///	Xg[nt@C
	virtual LRESULT		Open(const string& filename,const string& access);	//	StreamnOpen
	virtual LRESULT		Write(const string&);								//	StreamnWrite
	virtual LRESULT		Close();											//	Close
	virtual FILE*		GetFilePtr()const { return m_lpFile; }
	/**
	OpenŃt@Cw肵AI[v܂B
	access̓ANZXwqŁAfopenŎw肷̂ƓłB
	WritéAo͂܂iꂵL܂j
	CloséAt@C܂B
	̂ƂGetFilePtrŃI[vĂt@CFILE*̂ŁA
	ԐڂŏōsƂ͏o܂B
	tɃ[U[OpenFILE*SetFilePtrŐݒ肵A
	CFilẽo֐(ƌĂWriteClose炢܂)gƂo܂B
	*/

	///	ꊇǂݍ݌n
	///	Readœǂݍ񂾂̂ɂ́AClose()Ăяo
	/**
	t@C"c:\"Ƃ̂悤:܂܂ĂȂ΁ANfBNg
	(SetCurrentDirŐݒ肳ĂfBNg)΃pXłB

	@C[WCFileɓǂݍ܂
	@Ƃ΁At@C炢ACFileReadœǂݍނ悤ȃNXƂA
	@ɔzuꂽC[Ww肵ꍇȂǂ́Ap̊֐pӂȂĂ͂Ȃ܂B
	@̂悤ȕCFilełzĂΗǂƎv̂ŁA
	@ɔzuf[^Aȉ̂悤ɂāuIvŎn܂A
	@PUi̕Ń̐擪AhXƁÃubÑTCYt@CƂĎw肵Ă
	@CFiléAt@CƍoAt@Cł邩̂悤ɈƂo܂B
	@[]
	@@@LPCSTR lpsz = "\ł邩ȁH<HR>܂Ηǂ̂"
	@@@@@@@@@@"ȒPłȂH<HR>Ă邢ĂDD<HR>";
	@@@::wsprintf(buf,"!%x,%x",lpsz,strlen(lpsz)+1);
	*/
	virtual LRESULT		Read(const string& filename);

	virtual string		GetName()const;
	///	ǂݍłt@CԂ
	virtual string		GetPureFileName();
	///		pXt@C擾
	virtual string		GetSuffix();
	///		ǂݍłt@C̊gqԂ
	virtual LPVOID		GetMemory()const;
	///		ǂݍł郁Ԃ
	virtual DWORD		GetSize()const;
	///		ǂݍłt@CTCYԂ

	/**
	ReadŃI[v܂BI[vuԂɁAɈꊇœǂݍ܂܂BReadœǂݍ񂾂̂ɂ́AClose()Ăяo܂BClose()Ăяo܂ŁAGetMemoryŎ擾t@C̓ei[Ă郁͗LłB
	*/

	///		ɓǂݍ񂾃t@Csǂݏo[`
	virtual LRESULT		ReadLine(LPSTR buf,DWORD dwSize=256);
	/// obt@dwSizeoCgpӂƂĂ˂
	///		Ԃl 0: I	1: EOF	2:obt@ӂ
	///		3:t@CǂݍłȂ

	virtual LRESULT		ReadLine2(LPSTR buf,DWORD dwSize=512);
	///		obt@dwSizeoCgpӂƂĂ˂
	///		́AViIt@C("..."1bZ[W,I"END"łt@C)̓ǂݍݗp

	virtual LRESULT		ReadLine(string&s);
	/// ́Aobt@͎OŗpӂȂėǂB
	///	Ԃl 0: I 1:EOF   3:t@CǂݍłȂOOG

	virtual void		Reset();
	///	ReadLineł̓ǂݍ݃|C^擪|C^ɖ߂

	virtual LRESULT		ReadData(BYTE*p,DWORD size);
	//	oCgPʂ̓ǂݏo

	///		ꊇ݌n
	///	CɃt@Cɏ݂܂Bkt@Cɂ͏o܂B
	virtual LRESULT		Write(const string& filename,LPVOID mem,DWORD size);

	///	ReadOpen̂߂܂Bkt@Cɂ͏߂܂B
	virtual LRESULT		WriteBack(const string& filename);

	///	ƂɈÍiPȂjuւj
	virtual LRESULT		Encode();	///	obt@GR[h

	///	t@C̍폜
	virtual LRESULT		Delete(const string& filename);

	virtual LRESULT		CreateTemporary();
	/**
	KvȂ΃e|t@C쐬oBiꊇǂݍ݌ñI[vĂ邱ƂOj
	̊֐ÍACFile̓t@C̒g͕ۗLĂȂB
	t@C͎Ă̂ŁAGetNameŃt@C̎擾͉\B
	e|t@C쐬́Aǂݍłt@Ckt@Cł邱ƁB
	e|t@C쐬ꍇ́AGetNameŕԂĂt@ĆÃt@CƂȂB
	e|t@ĆACloseAfXgN^ō폜B
	܂Ãt@Cł͎słȂAPI(FMCI֘A)ɑ΂Aꎞt@Cpӂ̂ɎgB
	*/

	///	f[^̕ۑ^ǂݍ(class CSerializeƕpƗǂ)
	virtual LRESULT		Load(const string& filename,vector<BYTE>*vData);
	virtual LRESULT		Save(const string& filename,vector<BYTE>*vData);

	//	f[^̕ۑ(ۑ)
	virtual LRESULT		Save(const string& filename,vector<string>*vData);

	///	-----------------------------------------------------
	///		@t@C̒Tpathݒ肷

	///	ReadƂPathݒ
	static void		SetPathList(const smart_ptr<vector<string> >& aszPathList){ m_aszPathList = aszPathList; }
	///	vListɂĂpXւt@CɍsB
	///	JgtH_̃pXD挟oHB
	///	pX̍Ōɂ́A'\'͕svB

	static smart_ptr<vector<string> > GetPathList() { return m_aszPathList; }

	///	-----------------------------------------------------

	///		NtH_on
	/**
	CFileΏۂƂĂ̂́ACFilẽom_szCurrentDirectoryłB
	́AGetCurrentDirSetCurrentDirĂяo܂ŏ܂B
	ÑJgtH_CFilȇΏۃtH_Ƃ̂ł΁A
	NCFile::SetCurrentDir()ĂяoKv܂B
	̊֐́Ã݂JgtH_CFilẽJgtH_ɐݒ肷邩łB
	WindowśA_CAOJătH_ړsȂƁAJgtH_
	ݒ肵Ă܂܂̂ŁAȂĂGetCurrentDirĂяoƁA
	CFilẽom_szCurrentDirectorýAĂȂ߁A
	̏uԁÃ݂JgtH_擾悤Ƃ܂A
	͈ړ̃tH_ł邽߁ANtH_΂ɂ͂Ȃ܂B
	ׂƂłACĂB

	class CFileInitializer Aclass CAppInitializer ̏R[obNɂ
	SetCurrentDir̂ŁAclass CAppInitializer pĂvOȂ
	ȏ̂Ƃ́ACɂȂėǂB
	*/
	static string	GetCurrentDir();
	/// ݁ACFileŃJgtH_ƂĐݒ肳ĂtH_擾

	static void		SetCurrentDir();
	/// ݂̃JgtH_ACFilẽJgtH_ɂ

	static void		SetCurrentDir(const string& dir);
	/// w肵pXCFilẽJgtH_ɂB

	static	LRESULT	GetParentDir(string& filename);
	//	etH_Ԃ
	/**
	j "c:\test1\test2\test3.exe" -> "c:\test1\test2\" -> "c:\test1\" -> "c:\" -> "c:\"Ƃ悤ɁAxĂяoƂɈetH_ɂȂBlbg[NhCuɂΉĂBiȉ̗j

	
	\\ -> \\
	\\aaa -> \\aaa\
	\\aaa\ -> \\aaa\
	\\aaa\bbb -> \\aaa\
	\\aaa\bbb\ -> \\aaa\
	\\aaa\bbb\ccc -> \\aaa\bbb\
	\\aaa\bbb\ccc\ -> \\aaa\bbb\
	\\aaa\bbb\ccc\ddd -> \\aaa\bbb\ccc\
	\\aaa\bbb\ccc\ddd\ -> \\aaa\bbb\ccc\
	\ -> \
	C: -> C:\
	C:\ -> C:\
	C:\aaa -> C:\
	C:\aaa\ -> C:\
	C:\aaa\bbb -> C:\aaa\
	C:\aaa\bbb\ -> C:\aaa\
	C:\aaa\bbb\ccc -> C:\aaa\bbb\
	C:\aaa\bbb\ccc\ -> C:\aaa\bbb\
	C:\aaa\bbb\ccc\ddd -> C:\aaa\bbb\ccc\
	C:\aaa\bbb\ccc\ddd\ -> C:\aaa\bbb\ccc\
	*/

	static string	MakeFullName(const string& filename);
	/// NfBNgĊSpX
	/**
	ˁ@̂ƂA / iXbVj́A \ iobNXbVj֕ϊ悤ɂȂĂ܂B
	@@iȂƁA܂ȂR[fbN݂邽߁j
	@@āA炩̓ǂݍ݊֐삷ꍇ́AȂ炸A
	@@MakeFullNameoRقƌ܂B
	*/

	static string	GetWindowsDir();
	///	WindowsfBNg̎擾iI['\'j

	///		t@C֘A񑀍n
	static string	GetSuffixOf(const string&);
	///		t@C̊gq擾

	static string	GetPureFileNameOf(const string&);
	///		pXtt@Ct@Ĉ݂擾

	static void		ToLower(string &);
	///		

	static LRESULT	GetTemporaryFileName(string& szFileName);
	///	e|t@C擾
	///	̊֐suԁAt@CÃt@CԂ

	/**
	t@ĆAIMakeFullNameŊSpXt̃t@CɕϊĂs܂B
	MakeFullNameɂ́ACFilẽom_szCurrentDirectoryg܂B
	ȋΏۃtH_ݒn̐ǂނƁj
	ŏ̌ĂяoiKŁÃoϐĂȂꍇ́A
	݂̃JgfBNg擾Am_szCurrentDirectoryɂ܂B
	ʏA̎dlŖȂƎv̂łA_CAOgꍇ͂̌ł͂܂B
	ӂĂB

	MakeFullNameł́A"../../test.wav"̂悤ȋ삯オpXT|[gĂ܂B
	Open̊֐łAŏɂ̊֐ĂяoăpX␳̂ŁA
	̂悤ȋ삯オpXpł܂B

	iꉞACAppInitializer::Init()SetCurrentDir()ĂяoĂ̂ŖȂƎv܂A
	@CFilẽvOɗpƂȂǂɂ͋CĂj

	܂At@Cǂݍ񂾂ƂɓIɊmۂ郁́A
	eLXgt@Cǂݍ񂾂ƂɁAŌ'\0'ۏ؂邽߁A
	PoCg߂ɊmۂčŌ̃oCg'\0'ɂĂ܂
*/

	static bool PathFileExists(const string& fullname);

	CFile();
	virtual ~CFile();

protected:
	LRESULT			InnerRead(const string& filename);				//	Readpatho[W
	LRESULT			InnerOpen(const string& filename,const string& access);	//	Openpatho[W

	FILE*			m_lpFile;			// ݎɎgp(cf.yanefileDLL)
	LPVOID			m_lpFileAdr;		// t@C̓ǂݍ񂾃AhX
	DWORD			m_dwFileSize;		// t@CTCYȂ́I
	LPSTR			m_lpFileMemPos;		// ReadLinê߂̃|WV
	string			m_szFileName;		// ǂݍłt@C
	bool			m_bEncode;
	bool			m_bTempFile;		//	e|t@CȂ̂H(close̍ۂɍ폜)
	bool			m_bCompress;		//	Openœǂݍ񂾃t@C͈kt@ĈH
	bool			m_bMemoryImage;		//	ɓǂݍ܂ꂽzt@C

	static string	m_szCurrentDirectory;		// ݑΏۂƂĂfBNg
	static smart_ptr<vector<string> >	m_aszPathList;	//pXXg
};

//	CFilẽO[oq
class CFileInitializer {
	static CFileInitializer m_dummy;
public:
	CFileInitializer();
};

#endif
