#include <iostream.h>
#include <stdio.h>
#include <math.h>
#include <windows.h>
#include "ygs_bulletml.h"
#include "MyRunner.h"
#include "Foe.h"
#include "FoeSystem.h"
#include "libBulletML/bulletmlerror.h"
#include "rand.h"
#include "yaneSDK2nd/stdafx.h"
#include "yaneSDK2nd/yaneFile.h"

#define BMLMAX 64
#define BMAX 2048 //eMAX(̃ftHgl)
#define EXPORT extern "C" __declspec(dllexport)

FoeSystem* foesys = NULL;
BulletMLParserTinyXML* parsers[BMLMAX]; //BMLp[T(BMLMAXނBML܂œo^\)
bool parser_flag[BMLMAX];

int tick=0;		 //Q[
int tama=0;		 //݂̒e
int bmax = BMAX; //eMAX
double jx,jy;	 //@̍W
double multi0=1;	 //Xs[h{(̃ftHgl)
double rot0 = 0;		 //cV[:0 V[:90

EXPORT long bml_init(long *p) {
	tick=0;
	tama=0;
	if((p[0] >= 1)||(p[0] <= BMAX)) {
		bmax  = p[0]; //e̍ő吔Zbg
	}
	/*
	if((p[1] >= 1)||(p[1] <= 16)) {
		multi0 = p[1]; //Xs[h{
	}
	*/

	CFile::SetCurrentDir();
	
	setSeed(765); //V[h(Mersenee Twist)
//	foesys = new FoeSystem(bmax);
	_bml_free();
	foesys->init(bmax);
	
	return bmax;
}

EXPORT long bml_setSeed(long *p) {
	if (p[0] < 0) return -1;
	setSeed(p[0]);
	return 0;
}

EXPORT long bml_nextRand(long *) {
	return nextRand();
}

EXPORT long bml_setRot(long *p) {
	if ((p[0] < 0)||(p[0] >= 360)) return -1;
	rot0 = (double)p[0];
	return 0;
}

/*
EXPORT long bml_changeMulti(long *p) {
	if (p[0] < 0) return -1;
	multi0 = p[0];
	return 0;
}
*/

EXPORT long bml_reset(long *p) {
	bml_deleteAll(p);
	for(int i=0; i<BMLMAX; i++) {
		if(parsers[i] != NULL) delete parsers[i];
		parsers[i] = NULL;
		parser_flag[i] = false;
	}
	return 0;
}

EXPORT long bml_loadBML(long *p) {
	long mlno = p[0];
	char* fname = (char*)p[1];
	CFile f;

	if ((mlno<0)||(mlno>=BMLMAX)) return -1;
	if (parser_flag[mlno] == true) return -2;

/*
	FILE* fp = fopen((char*)fname,"r");
	if (fp == NULL) {
//		fprintf(stderr,"t@C(%s)J܂B\n",fname);
		return -3;
	}else
		fclose(fp);
*/
	if(f.Read(fname)) {
		return -3;
	}
	f.Close();
	
	try {
		parsers[mlno] = new BulletMLParserTinyXML((char*)fname);
		(parsers[mlno])->build();
		parser_flag[mlno] = true;
	}catch(BulletMLError error){
		return -4;
	}
	return mlno;
}

/*
EXPORT long bml_setBullet(long *p) {
	return _bml_setBullet((long*)p[0], (long*)p[1], (long*)p[2], (long*)p[3], p[4], p[5], p[6], p[7], p[8], multi0);
}
*/

EXPORT long bml_setBullet(long *p) {
	long *tf = (long*)p[0];
	long *tx = (long*)p[1];
	long *ty = (long*)p[2];
	long *tt = (long*)p[3];
	long mlno = p[4];
	long rank = p[5];
	long x    = p[6];
	long y    = p[7];
	long type = p[8];
	long rot   = p[9] + rot0;
	double multi = (double)p[10];
	
	if ((rank < 0)||(rank > 100)) return -1; //N̎w肪͈͊O(0`100)
	if ((mlno<0)||(mlno>=BMLMAX)) return -1; //p[T[̎wԍsB
	BulletMLParserTinyXML *parser = parsers[mlno];
	if(parser == NULL) return -1; //wԍ̃p[T[݂ȂB
	
	if (multi <= 0) {
		multi = multi0;
	} else {
		multi /= 256;
	}
	int no = foesys->action((double)x, (double)y, parser, (double)rank/100.0, type, multi, (double)rot);
	if(no<0) {
		return -1; //e̋󂫃GAmۂłȂI
	} else {
		Foe *f = foesys->get(no);
		tf[no] = 2; // with action
		tx[no] = (int)f->x;
		ty[no] = (int)f->y;
		tt[no] = f->type;
	}
	return no;
}

EXPORT long bml_setSimpleBullet(long *p) {
	long *tf  = (long*)p[0];
	long *tx = (long*)p[1];
	long *ty = (long*)p[2];
	long *tt = (long*)p[3];
	double x  = (double)p[4];
	double y  = (double)p[5];
	double dx = (double)p[6] / 256.0;
	double dy = (double)p[7] / 256.0;
	long type = p[8];

	int no = foesys->simple(x,y, dx,dy,type);
	if(no<0) {
		return -1; //e̋󂫃GAmۂłȂI
	} else {
		Foe *f = foesys->get(no);
		tf[no] = 1; // simple
		tx[no] = (int)f->x;
		ty[no] = (int)f->y;
		tt[no] = f->type;
	}
	return no;
}

EXPORT long bml_setSimpleAngleBullet(long *p) {
	long *tf  = (long*)p[0];
	long *tx = (long*)p[1];
	long *ty = (long*)p[2];
	long *tt = (long*)p[3];
	double x  = (double)p[4];
	double y  = (double)p[5];
	double dir  = (double)p[6];
	double spd = (double)p[7] / 256.0;
	long type = p[8];

	int no = foesys->simple2(x,y, dir, spd, type);
	if(no<0) {
		return -1; //e̋󂫃GAmۂłȂI
	} else {
		Foe *f = foesys->get(no);
		tf[no] = 1; // simple
		tx[no] = (int)f->x;
		ty[no] = (int)f->y;
		tt[no] = f->type;
	}
	return no;
}

EXPORT long bml_setSimpleAimBullet(long *p) {
	if ((p[4] == p[6])&&(p[5] == p[7])) return -1;
	long *tf  = (long*)p[0];
	long *tx = (long*)p[1];
	long *ty = (long*)p[2];
	long *tt = (long*)p[3];
	double sx  = (double)p[4];
	double sy  = (double)p[5];
	double tgx  = (double)p[6];
	double tgy  = (double)p[7];
	double spd = (double)p[8] / 256.0;
	long type = p[9];

	double dx = tgx - sx;
	double dy = tgy - sy;
	double dz = sqrt(dx*dx + dy*dy);
	dx = dx / dz * spd;
	dy = dy / dz * spd;
	
	int no = foesys->simple(sx,sy, dx,dy,type);
	if(no<0) {
		return -1; //e̋󂫃GAmۂłȂI
	} else {
		Foe *f = foesys->get(no);
		tf[no] = 1; // simple
		tx[no] = (int)f->x;
		ty[no] = (int)f->y;
		tt[no] = f->type;
	}
	return no;
}

/*
EXPORT long bml_setPosition(long *p) {
	long no   = p[0];
	double x    = (double)p[1];
	double y    = (double)p[2];

	Foe* f = foesys->get(no);
	f->x = x;
	f->y = y;
	
	return no;
}
*/

EXPORT long bml_deleteUnflag(long *p) {
	long *tf = (long*)p[0];

	Foe* f;
	// tfOɃZbgꂽe
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		if((tf[i]==0)&&(f->flag>0)) {
			f->vanish();
			tf[i] = 0;
		}
	}
	return tama;
}

EXPORT long bml_deleteDanmaku(long *p) {
	long *tf = (long*)p[0];
	long no = p[1];

	Foe* f;
	// eԍ[No]eƂe
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		if ((f->flag>0)&&(f->oya == no)) {
			f->vanish();
			tf[i] = 0;
		}
	}
	return tama;
}

EXPORT long bml_deleteAll(long *p) {
	long *tf = (long*)p[0];

	Foe* f;
	// SĂ̐Ăee
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		if(f->flag>0) {
			f->vanish();
			tf[i] = 0;
		}
	}
	return tama;
}

/*
EXPORT long bml_getDanmakuRoots(long *p) {
	long *tr = (long*)p[0];

	Foe* f;
	// e̒eNo.𓾂BVve-1, 󂫔Ԃ-2
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		if (f->flag>0) {
			tr[i] = f->oya;
		} else {
			tr[i] = -2;
		}
	}
	return tama;
}
*/

/*
EXPORT long bml_change2Simple(long *p) {
	// ANVeVveɕύX
	long no   = p[0];
	long *tf = (long*)p[1];
	long *tt = (long*)p[2];
	double dx = (double)p[3] / 256.0;
	double dy = (double)p[4] / 256.0;
	long type = p[5];

	Foe* f = foesys->get(no);
	if (f->flag == 0) {
		return -1;
	} else {
		f->vanish();
	}

	if(f->dx !=0 || f->dy != 0) f->init(f->x, f->y, f->dir, dx, dy, type, no, f->multi);
	tf[no] = 1;
	tt[no] = type;
	
	return no;
}
*/

EXPORT long bml_changeDanmaku2Simple(long *p) {
	// eNo=n̒e܂邲ƃVveɕςB
	long no   = p[0];
	long *tf = (long*)p[1];
	long *tt = (long*)p[2];
	double dx = (double)p[3] / 256.0;
	double dy = (double)p[4] / 256.0;
	long type = p[5];
	
	Foe* f;
	// eԍ[No]eƂe + VveɕύX
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		if ((f->flag>0)&&(f->oya == no)) {
			f->vanish();
			if (i == no) {
				tf[i] = 0;
				continue;
			}
			f->init(f->x, f->y, f->dir, dx, dy, type, no, multi0);
			tf[i] = 1;
			tt[i] = type;
		}
	}
	return tama;
}

EXPORT long bml_changeDanmaku2SimpleAngle(long *p) {
	// eNo=n̒e܂邲ƃVve(pxw)ɕςB
	long no   = p[0];
	long *tf = (long*)p[1];
	long *tt = (long*)p[2];
	double dir  = (double)p[3];
	double spd = (double)p[4] / 256.0;
	long type = p[5];

	double dx = sin((dir+rot0)/180*3.14)*spd;
	double dy = -cos((dir+rot0)/180*3.14)*spd;
	
	Foe* f;
	// eԍ[No]eƂe + VveɕύX
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		if ((f->flag>0)&&(f->oya == no)) {
			f->vanish();
			if (i == no) {
				tf[i] = 0;
				continue;
			}
			f->init(f->x, f->y, dir+rot0, dx, dy, type, no, multi0);
			tf[i] = 1;
			tt[i] = type;
		}
	}
	return tama;
}

/*
EXPORT long bml_change2Action(long *p) {
	// ANVewANVeɕύX
	long no   = p[0];
	long *tf = (long*)p[1];
	long *tt = (long*)p[2];
	long mlno = p[3];
	long rank  = p[4];
	long type  = p[5];
	long multi = p[6];
	long rot = p[7];

	Foe* f = foesys->get(no);
	if (f->flag == 0) {
		return -1;
	} else {
		f->vanish();
	}

	if ((rank < 0)||(rank > 100)) return -1; //N̎w肪͈͊O(0`100)
	if ((mlno<0)||(mlno>=BMLMAX)) return -1; //p[T[̎wԍsB
	BulletMLParserTinyXML *parser = parsers[mlno];
	if(parser == NULL) return -1; //wԍ̃p[T[݂ȂB
	
	f->init(f->x, f->y, 180.0, new MyRunner(no, parser, rank, rot), type, no, multi, 3);
	tf[no] = 3;
	tt[no] = type;
	
	return no;
}
*/

EXPORT long bml_changeDanmaku2Action(long *p) {
	// eNo=n̒e܂邲ƎwANVeɕύX
	long no   = p[0];
	long *tf = (long*)p[1];
	long *tt = (long*)p[2];
	long mlno = p[3];
	long rank  = p[4];
	long type  = p[5];
	long multi = p[6];
	long rot = p[7] + rot0;

	if ((rank < 0)||(rank > 100)) return -1; //N̎w肪͈͊O(0`100)
	if ((mlno<0)||(mlno>=BMLMAX)) return -1; //p[T[̎wԍsB
	BulletMLParserTinyXML *parser = parsers[mlno];
	if(parser == NULL) return -1; //wԍ̃p[T[݂ȂB

	Foe* f;
	// eԍ[No]eƂe + ANVeɕύX
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		if ((f->flag>0)&&(f->oya == no)) {
			f->vanish();
			if (i == no) {
				tf[i] = 0;
				continue;
			}
			f->init(f->x, f->y, 180.0, new MyRunner(i, parser, rank, rot), type, no, multi, 3);
			tf[i] = 3;
			tt[i] = type;
		}
	}
	
	return no;
}

EXPORT long bml_run(long *p) {
	jx = (double)p[0];
	jy = (double)p[1];
	long *tf = (long*)p[2];
	long *tx = (long*)p[3];
	long *ty = (long*)p[4];
	long *tt = (long*)p[5];
	long *td = (long*)p[6];
	long *tr = (long*)p[7];
	long *tc = (long*)p[8];

	Foe* f;
	//(1) tfOɃZbgꂽeA܂tx[], ty[], tt[]ύX **DEL(tf[i]3rbgڂ1̎)DEL**
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		if (tf[i]==0) {
			if (f->flag>0) {
				f->vanish();
			}
		} else /* if (tf[i]&4) */ {
			f->x    = (f->x - (int)f->x) + tx[i];
			f->y    = (f->y - (int)f->y) + ty[i];
			f->type = tt[i];
//			tf[i] = tf[i] & 3;
		}
	}

	//(2) e̎s(Runners{ړ)
//	printf("yTURN %dz\n", tick);
	foesys->run();

	//(3) eʂ̃Zbg
	for(int i=0; i<bmax; i++) {
		f = foesys->get(i);
		tf[i] = f->flag;
		if(f->flag) {
			tx[i] = (int)f->x;
			ty[i] = (int)f->y;
			tt[i] = f->type;
			if (td) {
				//td[i] = (int)(f->dir + 360) % 360;
				int dir = (int)f->dir - rot0;
				while(dir < 0) dir += 360;
				while(dir >= 360) dir -= 360;
				td[i] = dir;
			}
			if (tc) tc[i] = f->term;
		}
	}
	if (tr) {
		for(int i=0; i<bmax; i++) {
			f = foesys->get(i);
			if (f->flag>0) {
				tr[i] = f->oya;
			} else {
				tr[i] = -2;
			}
		}
	}

	tick++;
	return tama;
}

EXPORT long bml_quit(long *) {
	_bml_free();
	return 0;
}

void _bml_free(void) {
	// SĂ̐Ăee
	Foe* f;
	if(foesys != NULL) {
		for(int i=0; i<bmax; i++) {
			f = foesys->get(i);
			if(f) {
				if(f->flag>0) {
					f->vanish();
				}
			}
		}
//		foesys->free();
//		delete foesys;
	}
	
	//SẴp[T[
	for(int i=0; i<BMLMAX; i++) {
		if(parsers[i] != NULL) delete parsers[i];
		parsers[i] = NULL;
		parser_flag[i] = false;
	}
}

extern "C" __declspec( dllexport ) SDllTable* InquireFunction(void){
	static SDllTable S[] = {
		//	ɁADLLŎgĂ֐񋓂
		"bml_init", bml_init,
		"bml_setSeed", bml_setSeed,
		"bml_nextRand", bml_nextRand,
		"bml_setRot", bml_setRot,
//		"bml_changeMulti", bml_changeMulti,
		"bml_reset", bml_reset,
		"bml_loadBML", bml_loadBML,
		"bml_setBullet", bml_setBullet,
//		"bml_setBullet2", bml_setBullet2,
		"bml_setSimpleBullet", bml_setSimpleBullet,
		"bml_setSimpleAngleBullet", bml_setSimpleAngleBullet,
		"bml_setSimpleAimBullet", bml_setSimpleAimBullet,
//		"bml_setPosition", bml_setPosition,
		"bml_deleteUnflag", bml_deleteUnflag,
		"bml_deleteDanmaku", bml_deleteDanmaku,
		"bml_deleteAll", bml_deleteAll,
//		"bml_getDanmakuRoots", bml_getDanmakuRoots,
//		"bml_change2Simple", bml_change2Simple,
//		"bml_change2Action", bml_change2Action,
		"bml_changeDanmaku2Simple", bml_changeDanmaku2Simple,
		"bml_changeDanmaku2SimpleAngle", bml_changeDanmaku2SimpleAngle,
		"bml_changeDanmaku2Action", bml_changeDanmaku2Action,
		"bml_run", bml_run,
		"bml_quit", bml_quit,
		//	ygs2k"FillMemory"Ƃ֐ǉB
		//	FillMemoryŌĂяốADLLfFillMemoryłB
		NULL,NULL	// ŌNULL,NULL
	};
	return &S[0];
}

int WINAPI DllMain(HINSTANCE, DWORD fdwReason, PVOID)
{
//	char szBuf[256];

	switch(fdwReason) {
	  case DLL_PROCESS_ATTACH:
		foesys = new FoeSystem(BMAX);
		break;
	  case DLL_PROCESS_DETACH:
		delete foesys;
		break;
	  case DLL_THREAD_ATTACH:
//		lstrcpy(szBuf, "thread attach");
		break;
	  case DLL_THREAD_DETACH:
//		lstrcpy(szBuf, "thread detach");
		break;
	}
//	MessageBox(NULL, szBuf, "DllMain", MB_OK);
    return TRUE;
}
