#ifndef YGS_BULLETML_H_
#define YGS_BULLETML_H_

#include "FoeSystem.h"
#include "libBulletML/bulletmlparser.h"
#include "libBulletML/bulletmlparser-tinyxml.h"
#include "libBulletML/bulletmlrunner.h"
#include <windows.h>
#define EXPORT extern "C" __declspec(dllexport)

extern int tick;		//Q[
extern int tama;		//݂̒e
extern double jx,jy;	//@̍W
extern int  bmax;		//eMAX
extern double multi0;		//Xs[h{(̃ftHgl)
extern double rank;		//N

extern FoeSystem* foesys;	//eǗpIuWFNg
extern BulletMLParserTinyXML* parsers[];	//BMLp[T x 16

EXPORT long bml_init(long *p);
EXPORT long bml_setSeed(long *p);
EXPORT long bml_nextRand(long *);
EXPORT long bml_setRot(long *p);
//EXPORT long bml_changeMulti(long *p);
EXPORT long bml_reset(long *p);
EXPORT long bml_loadBML(long *p);
EXPORT long bml_setBullet(long *p);
//EXPORT long bml_setBullet2(long *p);
EXPORT long bml_setSimpleBullet(long *p);
EXPORT long bml_setSimpleAngleBullet(long *p);
EXPORT long bml_setSimpleAimBullet(long *p);
//EXPORT long bml_setPosition(long *p);
EXPORT long bml_deleteUnflag(long *p);
EXPORT long bml_deleteDanmaku(long *p);
EXPORT long bml_deleteAll(long *p);
//EXPORT long bml_getDanmakuRoots(long *p);
//EXPORT long bml_change2Simple(long *p);
//EXPORT long bml_change2Action(long *p);
EXPORT long bml_changeDanmaku2Simple(long *p);
EXPORT long bml_changeDanmaku2SimpleAngle(long *p);
EXPORT long bml_changeDanmaku2Action(long *p);
EXPORT long bml_run(long *p);
/*
EXPORT long bml_run2(long *p);
EXPORT long bml_run3(long *p);
long _bml_run(long *tf, long *tx, long *ty, long *tt, long *td, long *tc);
*/
EXPORT long bml_quit(long *p);
void _bml_free(void);
//long _bml_setBullet(long *tf, long *tx, long *ty, long *tt, long mlno, long rank, long x, long y, long type, long multi);

struct SDllTable {
	LPSTR	lpFuncName;
	LONG	(*lpFunc)(LONG*);
};
extern "C" __declspec( dllexport ) SDllTable* InquireFunction(void);

#endif
